package cn.ibizlab.humanresource.core.humanresource.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.humanresource.core.humanresource.domain.HRDuty;
import cn.ibizlab.humanresource.core.humanresource.filter.HRDutySearchContext;
import cn.ibizlab.humanresource.core.humanresource.service.IHRDutyService;

import cn.ibizlab.humanresource.util.helper.CachedBeanCopier;
import cn.ibizlab.humanresource.util.helper.DEFieldCacheMap;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.humanresource.core.humanresource.mapper.HRDutyMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[职务] 服务对象接口实现
 */
@Slf4j
@Service("HRDutyServiceImpl")
public class HRDutyServiceImpl extends ServiceImpl<HRDutyMapper, HRDuty> implements IHRDutyService {

    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRDutyCertService hrdutycertService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRDutyEduService hrdutyeduService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRDutySkillService hrdutyskillService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRPostService hrpostService;

    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(HRDuty et) {
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getHrdutyid()),et);
        return true;
    }

    @Override
    public void createBatch(List<HRDuty> list) {
        this.saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean update(HRDuty et) {
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("hrdutyid",et.getHrdutyid())))
            return false;
        CachedBeanCopier.copy(get(et.getHrdutyid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<HRDuty> list) {
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public HRDuty get(String key) {
        HRDuty et = getById(key);
        if(et==null){
            et=new HRDuty();
            et.setHrdutyid(key);
        }
        else{
        }
        return et;
    }

    @Override
    public HRDuty getDraft(HRDuty et) {
        return et;
    }

    @Override
    public boolean checkKey(HRDuty et) {
        return (!ObjectUtils.isEmpty(et.getHrdutyid()))&&(!Objects.isNull(this.getById(et.getHrdutyid())));
    }
    @Override
    @Transactional
    public boolean save(HRDuty et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(HRDuty et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public boolean saveBatch(Collection<HRDuty> list) {
        saveOrUpdateBatch(list,batchSize);
        return true;
    }

    @Override
    public void saveBatch(List<HRDuty> list) {
        saveOrUpdateBatch(list,batchSize);
    }



    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<HRDuty> searchDefault(HRDutySearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<HRDuty> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<HRDuty>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }







    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<HRDuty> getHrdutyByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<HRDuty> getHrdutyByEntities(List<HRDuty> entities) {
        List ids =new ArrayList();
        for(HRDuty entity : entities){
            Serializable id=entity.getHrdutyid();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0)
           return this.listByIds(ids);
        else
           return entities;
    }

}



